#ifndef LOGIN_H
#define LOGIN_H

#include <QDialog>

namespace Ui {
class login;
}

/**
 * @brief The Login class represents the login window
 *
 * After clicking the login button, signal with the credentials is emitted
 * to main window and the object is closed
 */
class Login : public QDialog
{
    Q_OBJECT

public:
    explicit Login(QWidget *parent = nullptr);
    ~Login();
    Login &operator=(const Login&) = delete;
    Login(const Login&) = delete;

signals:
    void login_clicked(QString name, QString password);

private slots:
    void on_loginButton_clicked();

    void on_cancelButton_clicked();

private:
    std::unique_ptr<Ui::login> ui;
};

#endif // LOGIN_H
