#ifndef REGISTER_H
#define REGISTER_H

#include <QDialog>

namespace Ui {
class Register;
}

/**
 * @brief The Register class represents the register window
 *
 * When the text in password lines has been changed, a signal
 * starts the "textChanged" functions to check if the passwords
 * typed are the same, the register button closes the window
 * and returns the name and password through a signal
 */
class Register : public QDialog
{
    Q_OBJECT

public:
    explicit Register(QWidget *parent = nullptr);
    ~Register();
    Register &operator=(const Register&) = delete;
    Register(const Register&) = delete;

signals:
    void register_clicked(QString name, QString password);

private slots:
    void on_passcheckEdit_textChanged(const QString &arg1);

    void on_passwordEdit_textChanged(const QString &arg1);

    void on_registerButton_clicked();

    void on_cancelButton_clicked();

private:
    std::unique_ptr<Ui::Register> ui;
};

#endif // REGISTER_H
