#pragma once

#include <wschatcom/Message.h>

#include <vector>
#include <thread>
#include <queue>
#include <mutex>
#include <condition_variable>

#include <QJsonObject>

class QWebSocket;
class ChatServer;

struct Job
{
    QWebSocket *socket;
    Message msg;
};

class Worker
{
public:
    explicit Worker(ChatServer &server);

    Worker(unsigned numberOfThreads, ChatServer &server);

    ~Worker();

    Worker(const Worker &) = delete;

    Worker(Worker &&) = delete;

    Worker &operator=(const Worker &) = delete;

    Worker &operator=(Worker &&) = delete;

    void addJob(Job job);
private:
    void work();

    void processJob(Job job) const;

    unsigned m_numberOfThreads{1};
    ChatServer &m_server;
    std::mutex m_mutex;
    std::condition_variable m_condition;
    bool m_terminate{false};
    std::vector<std::thread> m_threads;
    std::queue<Job> m_jobs;
};
